<?php
/*
Plugin Name: درگاه پرداخت سپرده برای Restrict Content Pro
Version: 3.2.4
Requires at least: 4.0
Description: درگاه پرداخت <a href="http://www.sepordeh.com/" target="_blank"> سپرده </a> برای افزونه Restrict Content Pro
Plugin URI: http://sepordeh.com
Author: حنّان ابراهیمی ستوده Update to new  A.Y
Author URI: http://sepordeh.com
 */
if (!defined('ABSPATH')) {
    exit;
}
require_once 'HANNANStd_Session.php';
if (!class_exists('RCP_Sepordeh')) {
    class RCP_Sepordeh
    {

        #webhooks
        public function process_webhooks()
        {}
        /**
         * Use this space to enqueue any extra JavaScript files.
         *
        access public
        @return void
         */
        #script
        public function scripts()
        {}
        /**
         * Load any extra fields on the registration form
         *
         * @access public
         * @return string
         */
        #fields
        public function fields()
        {
            /* Example for loading the credit card fields :
        ob_start();
        rcp_get_template_part( 'card-form' );
        return ob_get_clean();
         */
        }

        #validateFields
        public function validate_fields()
        {
            /* Example :
        if ( empty( $_POST['rcp_card_cvc'] ) ) {
        rcp_errors()->add( 'missing_card_code', __( 'The security code you have entered is invalid', 'rcp' ), 'register' );
        }
         */
        }

        #supports

        // public $supports = array();
        public function supports($item = '')
        {
            return;
        }
        /**
         * Generate a transaction ID
         *
         * Used in the manual payments gateway.
         *
         * @return string
         */
        public function __construct()
        {
            add_action('init', array($this, 'Sepordeh_Verify_By_HANNANStd'));
            add_action('rcp_payments_settings', array($this, 'Sepordeh_Setting_By_HANNANStd'));
            add_action('rcp_gateway_Sepordeh', array($this, 'Sepordeh_Request_By_HANNANStd'));
            add_filter('rcp_payment_gateways', array($this, 'Sepordeh_Register_By_HANNANStd'));
            add_filter('rcp_currencies', array($this, 'RCP_IRAN_Currencies_By_HANNANStd'));
            add_filter('rcp_irr_currency_filter_before', array($this, 'RCP_IRR_Before_By_HANNANStd'), 10, 3);
            add_filter('rcp_irr_currency_filter_after', array($this, 'RCP_IRR_After_By_HANNANStd'), 10, 3);
            add_filter('rcp_irt_currency_filter_before', array($this, 'RCP_IRT_Before_By_HANNANStd'), 10, 3);
            add_filter('rcp_irt_currency_filter_after', array($this, 'RCP_IRT_After_By_HANNANStd'), 10, 3);
        }

        public function RCP_IRR_Before_By_HANNANStd($formatted_price, $currency_code, $price)
        {
            return __('ریال', 'rcp') . ' ' . $price;
        }

        public function RCP_IRR_After_By_HANNANStd($formatted_price, $currency_code, $price)
        {
            return $price . ' ' . __('ریال', 'rcp');
        }

        public function RCP_IRT_Before_By_HANNANStd($formatted_price, $currency_code, $price)
        {
            return __('تومان', 'rcp') . ' ' . $price;
        }

        public function RCP_IRT_After_By_HANNANStd($formatted_price, $currency_code, $price)
        {
            return $price . ' ' . __('تومان', 'rcp');
        }

        public function RCP_IRAN_Currencies_By_HANNANStd($currencies)
        {
            unset($currencies['RIAL'], $currencies['IRR'], $currencies['IRT']);
            $iran_currencies = array(
                'IRT' => __('تومان ایران (تومان)', 'rcp'),
                'IRR' => __('ریال ایران (ریال)', 'rcp'),
            );

            return array_unique(array_merge($iran_currencies, $currencies));
        }

        public function Sepordeh_Register_By_HANNANStd($gateways)
        {
            global $rcp_options;

            if (version_compare(RCP_PLUGIN_VERSION, '2.1.0', '<')) {
                $gateways['Sepordeh'] = isset($rcp_options['sepordeh_name']) ? $rcp_options['sepordeh_name'] : __('سپرده', 'rcp_sepordeh');
            } else {
                $gateways['Sepordeh'] = array(
                    'label' => isset($rcp_options['sepordeh_name']) ? $rcp_options['sepordeh_name'] : __('سپرده', 'rcp_sepordeh'),
                    'admin_label' => isset($rcp_options['sepordeh_name']) ? $rcp_options['sepordeh_name'] : __('سپرده', 'rcp_sepordeh'),
                    'class' => 'rcp_sepordeh',
                );
            }

            return $gateways;
        }

        public function Sepordeh_Setting_By_HANNANStd($rcp_options)
        {
            ?>
            <hr/>
            <table class="form-table">
                <?php do_action('RCP_Sepordeh_before_settings', $rcp_options);?>
                <tr valign="top">
                    <th colspan=2><h3><?php _e('تنظیمات سپرده', 'rcp_sepordeh');?></h3></th>
                </tr>
                <tr valign="top">
                    <th>
                        <label for="rcp_settings[sepordeh_merchant]"><?php _e('مرچنت سپرده', 'rcp_sepordeh');?></label>
                    </th>
                    <td>
                        <input class="regular-text" id="rcp_settings[sepordeh_merchant]" style="width: 300px;"
                               name="rcp_settings[sepordeh_merchant]"
                               value="<?php if (isset($rcp_options['sepordeh_merchant'])) {
                echo $rcp_options['sepordeh_merchant'];
            }?>"/>
                    </td>
                </tr>
                <tr valign="top">
                    <th>
                        <label for="rcp_settings[sepordeh_query_name]"><?php _e('نام لاتین درگاه', 'rcp_sepordeh');?></label>
                    </th>
                    <td>
                        <input class="regular-text" id="rcp_settings[sepordeh_query_name]" style="width: 300px;"
                               name="rcp_settings[sepordeh_query_name]"
                               value="<?php echo isset($rcp_options['sepordeh_query_name']) ? $rcp_options['sepordeh_query_name'] : 'Sepordeh'; ?>"/>
                        <div class="description"><?php _e('این نام در هنگام بازگشت از بانک در آدرس بازگشت از بانک نمایان خواهد شد . از به کاربردن حروف زائد و فاصله جدا خودداری نمایید . این نام باید با نام سایر درگاه ها متفاوت باشد .', 'rcp_sepordeh');?></div>
                    </td>
                </tr>
                <tr valign="top">
                    <th>
                        <label for="rcp_settings[sepordeh_name]"><?php _e('نام نمایشی درگاه', 'rcp_sepordeh');?></label>
                    </th>
                    <td>
                        <input class="regular-text" id="rcp_settings[sepordeh_name]" style="width: 300px;"
                               name="rcp_settings[sepordeh_name]"
                               value="<?php echo isset($rcp_options['sepordeh_name']) ? $rcp_options['sepordeh_name'] : __('سپرده', 'rcp_sepordeh'); ?>"/>
                    </td>
                </tr>
                <tr valign="top">
                    <th>
                        <label><?php _e('تذکر ', 'rcp_sepordeh');?></label>
                    </th>
                    <td>
                        <div class="description"><?php _e('از سربرگ مربوط به ثبت نام در تنظیمات افزونه حتما یک برگه برای بازگشت از بانک انتخاب نمایید . ترجیحا نامک برگه را لاتین قرار دهید .<br/> نیازی به قرار دادن شورت کد خاصی در برگه نیست و میتواند برگه ی خالی باشد .', 'rcp_sepordeh');?></div>
                    </td>
                </tr>
                <?php do_action('RCP_Sepordeh_after_settings', $rcp_options);?>
            </table>
            <?php
}

        public function Sepordeh_Request_By_HANNANStd($subscription_data)
        {

            $new_subscription_id = get_user_meta($subscription_data['user_id'], 'rcp_subscription_level', true);
            if (!empty($new_subscription_id)) {
                update_user_meta($subscription_data['user_id'], 'rcp_subscription_level_new', $new_subscription_id);
            }

            $old_subscription_id = get_user_meta($subscription_data['user_id'], 'rcp_subscription_level_old', true);
            update_user_meta($subscription_data['user_id'], 'rcp_subscription_level', $old_subscription_id);

            global $rcp_options;
            ob_start();
            $query = isset($rcp_options['sepordeh_query_name']) ? $rcp_options['sepordeh_query_name'] : 'Sepordeh';
            $amount = str_replace(',', '', $subscription_data['price']);
            //fee is just for paypal recurring or ipn gateway ....
            //$amount = $subscription_data['price'] + $subscription_data['fee'];

            $sepordeh_payment_data = array(
                'user_id' => $subscription_data['user_id'],
                'subscription_name' => $subscription_data['subscription_name'],
                'subscription_key' => $subscription_data['key'],
                'amount' => $amount,
            );

            $HANNANStd_session = HANNAN_Session::get_instance();
            @session_start();
            $HANNANStd_session['sepordeh_payment_data'] = $sepordeh_payment_data;
            $_SESSION["sepordeh_payment_data"] = $sepordeh_payment_data;

            //Action For Sepordeh or RCP Developers...
            do_action('RCP_Before_Sending_to_Sepordeh', $subscription_data);

            if (!in_array($rcp_options['currency'], array(
                'irt',
                'IRT',
                'تومان',
                __('تومان', 'rcp'),
                __('تومان', 'rcp_sepordeh'),
            ))) {
                $amount = $amount / 10;
            }

            //Start of Sepordeh
            $MerchantID = isset($rcp_options['sepordeh_merchant']) ? $rcp_options['sepordeh_merchant'] : '';
            $Amount = intval($amount);
            $Email = isset($subscription_data['user_email']) ? $subscription_data['user_email'] : '-';
            $CallbackURL = add_query_arg('gateway', $query, $subscription_data['return_url']);
            $Description = sprintf(__('خرید اشتراک %s برای کاربر %s', 'rcp_sepordeh'), $subscription_data['subscription_name'], $subscription_data['user_name']);
            $Mobile = '-';

            //Filter For Sepordeh or RCP Developers...
            $Description = apply_filters('RCP_Sepordeh_Description', $Description, $subscription_data);
            $Mobile = apply_filters('RCP_Mobile', $Mobile, $subscription_data);

         
        $url='https://sepordeh.com/merchant/invoices/add';
		$params=array(
		'merchant'          => $MerchantID,
		'amount'       => $Amount,
		'callback'     => $CallbackURL,
		'orderId' => time(),
		'description'  => $Description,
	);
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	$res = curl_exec($ch);
	curl_close($ch);

	$result = json_decode($res);
if($result->status==200) {
	$go = "https://sepordeh.com/merchant/invoices/pay/automatic:true/id:".$result->information->invoice_id;
                ob_end_clean();
                if (!headers_sent()) {
                    header('Location: ' . $go);
                    exit;
                } else {
                    $redirect_page =  $go;
                    echo "<script type='text/javascript'>window.onload = function () { top.location.href = '" . $redirect_page . "'; };</script>";
                    exit;
                }
            } else {
                wp_die(sprintf(__('متاسفانه پرداخت به دلیل خطای زیر امکان پذیر نمی باشد . <br/><b> %s </b>', 'rcp_sepordeh'), $this->Fault($result->status)));
            }
            //End of Sepordeh

            exit;
        }

        public function Sepordeh_Verify_By_HANNANStd()
        {

            if (!isset($_GET['gateway'])) {
                return;
            }

            if (!class_exists('RCP_Payments')) {
                return;
            }

            global $rcp_options, $wpdb, $rcp_payments_db_name;
            @session_start();
            $HANNANStd_session = HANNAN_Session::get_instance();
            if (isset($HANNANStd_session['sepordeh_payment_data'])) {
                $sepordeh_payment_data = $HANNANStd_session['sepordeh_payment_data'];
            } else {
                $sepordeh_payment_data = isset($_SESSION["sepordeh_payment_data"]) ? $_SESSION["sepordeh_payment_data"] : '';
            }

            $query = isset($rcp_options['sepordeh_query_name']) ? $rcp_options['sepordeh_query_name'] : 'Sepordeh';

            if (($_GET['gateway'] == $query) && $sepordeh_payment_data) {

                $user_id = $sepordeh_payment_data['user_id'];
                $user_id = intval($user_id);
                $subscription_name = $sepordeh_payment_data['subscription_name'];
                $subscription_key = $sepordeh_payment_data['subscription_key'];
                $amount = $sepordeh_payment_data['amount'];

                /*
                $subscription_price = intval(number_format( (float) rcp_get_subscription_price( rcp_get_subscription_id( $user_id ) ), 2)) ;
                 */

                $payment_method = isset($rcp_options['sepordeh_name']) ? $rcp_options['sepordeh_name'] : __('سپرده طلایی', 'rcp_sepordeh');

                $new_payment = 1;
                if ($wpdb->get_results($wpdb->prepare("SELECT id FROM " . $rcp_payments_db_name . " WHERE `subscription_key`='%s' AND `payment_type`='%s';", $subscription_key, $payment_method))) {
                    $new_payment = 0;
                }

                unset($GLOBALS['sepordeh_new']);
                $GLOBALS['sepordeh_new'] = $new_payment;
                global $new;
                $new = $new_payment;

                if ($new_payment == 1) {

                    //Start of Sepordeh
                    $MerchantID = isset($rcp_options['sepordeh_merchant']) ? $rcp_options['sepordeh_merchant'] : '';
                    $Amount = intval($amount);
                    if (!in_array($rcp_options['currency'], array(
                        'irt',
                        'IRT',
                        'تومان',
                        __('تومان', 'rcp'),
                        __('تومان', 'rcp_sepordeh'),
                    ))) {
                        $Amount = $Amount / 10;
                    }

                    $Authority = isset($_GET['authority']) ? sanitize_text_field($_GET['authority']) : '';

                    $__param = $Authority;
                    RCP_check_verifications(__CLASS__, $__param);

                   if (strlen($Authority)>0) {

                        $data = array('MerchantID' => $MerchantID, 'Authority' => $Authority, 'Amount' => $Amount);
                      
$url='https://sepordeh.com/merchant/invoices/verify';
$params= [
		'merchant' 	=> $MerchantID,
		'authority' => $Authority,
	];
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	$res = curl_exec($ch);
	curl_close($ch);
$result = json_decode($res);
                       if($result->status==200)  {
                            $payment_status = 'completed';
                            $fault = 0;
                            $transaction_id = $result->information->invoice_id;
                        } else {
                            $payment_status = 'failed';
                            $fault = $result->status;
                            $transaction_id = 0;
                        }
                    } else {
                        $payment_status = 'cancelled';
                        $fault = 0;
                        $transaction_id = 0;
                    }
                    //End of Sepordeh

                    unset($GLOBALS['sepordeh_payment_status']);
                    unset($GLOBALS['sepordeh_transaction_id']);
                    unset($GLOBALS['sepordeh_fault']);
                    unset($GLOBALS['sepordeh_subscription_key']);
                    $GLOBALS['sepordeh_payment_status'] = $payment_status;
                    $GLOBALS['sepordeh_transaction_id'] = $transaction_id;
                    $GLOBALS['sepordeh_subscription_key'] = $subscription_key;
                    $GLOBALS['sepordeh_fault'] = $fault;
                    global $sepordeh_transaction;
                    $sepordeh_transaction = array();
                    $sepordeh_transaction['sepordeh_payment_status'] = $payment_status;
                    $sepordeh_transaction['sepordeh_transaction_id'] = $transaction_id;
                    $sepordeh_transaction['sepordeh_subscription_key'] = $subscription_key;
                    $sepordeh_transaction['sepordeh_fault'] = $fault;

                    if ($payment_status == 'completed') {

                        $payment_data = array(
                            'date' => date('Y-m-d g:i:s'),
                            'subscription' => $subscription_name,
                            'payment_type' => $payment_method,
                            'subscription_key' => $subscription_key,
                            'amount' => $amount,
                            'user_id' => $user_id,
                            'transaction_id' => $transaction_id,
                        );

                        //Action For Sepordeh or RCP Developers...
                        do_action('RCP_Sepordeh_Insert_Payment', $payment_data, $user_id);

                        $rcp_payments = new RCP_Payments();
                        RCP_set_verifications($rcp_payments->insert($payment_data), __CLASS__, $__param);

                        $new_subscription_id = get_user_meta($user_id, 'rcp_subscription_level_new', true);
                        if (!empty($new_subscription_id)) {
                            update_user_meta($user_id, 'rcp_subscription_level', $new_subscription_id);
                        }
                        $membership = (array) rcp_get_memberships()[0];
                        $old_status_level = $membership;
                        $replace = str_replace('\u0000*\u0000', '', json_encode($old_status_level));
                        $replace = json_decode($replace, true);
                        $status = $replace['status'];
                        $idMemberShip = (int) $replace['id'];
                        $arrayMember = array(
                            'status' => 'active',
                        );
                        if ($status == 'pending') {
                            rcp_update_membership($idMemberShip, $arrayMember);
                        } else {
                            rcp_set_status($user_id, 'active');
                        }

                        if (version_compare(RCP_PLUGIN_VERSION, '2.1.0', '<')) {
                            rcp_email_subscription_status($user_id, 'active');
                            if (!isset($rcp_options['disable_new_user_notices'])) {
                                wp_new_user_notification($user_id);
                            }
                        }

                        update_user_meta($user_id, 'rcp_payment_profile_id', $user_id);

                        update_user_meta($user_id, 'rcp_signup_method', 'live');
                        //rcp_recurring is just for paypal or ipn gateway
                        update_user_meta($user_id, 'rcp_recurring', 'no');

                        $subscription = rcp_get_subscription_details(rcp_get_subscription_id($user_id));
                        $member_new_expiration = date('Y-m-d H:i:s', strtotime('+' . $subscription->duration . ' ' . $subscription->duration_unit . ' 23:59:59'));
                        rcp_set_expiration_date($user_id, $member_new_expiration);
                        delete_user_meta($user_id, '_rcp_expired_email_sent');

                        $log_data = array(
                            'post_title' => __('تایید پرداخت', 'rcp_sepordeh'),
                            'post_content' => __('پرداخت با موفقیت انجام شد . کد تراکنش : ', 'rcp_sepordeh') . $transaction_id . __(' .  روش پرداخت : ', 'rcp_sepordeh') . $payment_method,
                            'post_parent' => 0,
                            'log_type' => 'gateway_error',
                        );

                        $log_meta = array(
                            'user_subscription' => $subscription_name,
                            'user_id' => $user_id,
                        );

                        $log_entry = WP_Logging::insert_log($log_data, $log_meta);

                        //Action For Sepordeh or RCP Developers...
                        do_action('RCP_Sepordeh_Completed', $user_id);
                    }

                    if ($payment_status == 'cancelled') {

                        $log_data = array(
                            'post_title' => __('انصراف از پرداخت', 'rcp_sepordeh'),
                            'post_content' => __('تراکنش به دلیل انصراف کاربر از پرداخت ، ناتمام باقی ماند .', 'rcp_sepordeh') . __(' روش پرداخت : ', 'rcp_sepordeh') . $payment_method,
                            'post_parent' => 0,
                            'log_type' => 'gateway_error',
                        );

                        $log_meta = array(
                            'user_subscription' => $subscription_name,
                            'user_id' => $user_id,
                        );

                        $log_entry = WP_Logging::insert_log($log_data, $log_meta);

                        //Action For Sepordeh or RCP Developers...
                        do_action('RCP_Sepordeh_Cancelled', $user_id);

                    }

                    if ($payment_status == 'failed') {

                        $log_data = array(
                            'post_title' => __('خطا در پرداخت', 'rcp_sepordeh'),
                            'post_content' => __('تراکنش به دلیل خطای رو به رو ناموفق باقی باند :', 'rcp_sepordeh') . $this->Fault($fault) . __(' روش پرداخت : ', 'rcp_sepordeh') . $payment_method,
                            'post_parent' => 0,
                            'log_type' => 'gateway_error',
                        );

                        $log_meta = array(
                            'user_subscription' => $subscription_name,
                            'user_id' => $user_id,
                        );

                        $log_entry = WP_Logging::insert_log($log_data, $log_meta);

                        //Action For Sepordeh or RCP Developers...
                        do_action('RCP_Sepordeh_Failed', $user_id);

                    }

                }
                add_filter('the_content', array($this, 'Sepordeh_Content_After_Return_By_HANNANStd'));
                //session_destroy();
            }
        }

        public function Sepordeh_Content_After_Return_By_HANNANStd($content)
        {

            global $sepordeh_transaction, $new;

            $HANNANStd_session = HANNAN_Session::get_instance();
            @session_start();

            $new_payment = isset($GLOBALS['sepordeh_new']) ? $GLOBALS['sepordeh_new'] : $new;

            $payment_status = isset($GLOBALS['sepordeh_payment_status']) ? $GLOBALS['sepordeh_payment_status'] : $sepordeh_transaction['sepordeh_payment_status'];
            $transaction_id = isset($GLOBALS['sepordeh_transaction_id']) ? $GLOBALS['sepordeh_transaction_id'] : $sepordeh_transaction['sepordeh_transaction_id'];
            $fault = isset($GLOBALS['sepordeh_fault']) ? $this->Fault($GLOBALS['sepordeh_fault']) : $this->Fault($sepordeh_transaction['sepordeh_fault']);

            if ($new_payment == 1) {

                $sepordeh_data = array(
                    'payment_status' => $payment_status,
                    'transaction_id' => $transaction_id,
                    'fault' => $fault,
                );

                $HANNANStd_session['sepordeh_data'] = $sepordeh_data;
                $_SESSION["sepordeh_data"] = $sepordeh_data;

            } else {
                if (isset($HANNANStd_session['sepordeh_data'])) {
                    $sepordeh_payment_data = $HANNANStd_session['sepordeh_data'];
                } else {
                    $sepordeh_payment_data = isset($_SESSION["sepordeh_data"]) ? $_SESSION["sepordeh_data"] : '';
                }

                $payment_status = isset($sepordeh_payment_data['payment_status']) ? $sepordeh_payment_data['payment_status'] : '';
                $transaction_id = isset($sepordeh_payment_data['transaction_id']) ? $sepordeh_payment_data['transaction_id'] : '';
                $fault = isset($sepordeh_payment_data['fault']) ? $this->Fault($sepordeh_payment_data['fault']) : '';
            }

            $message = '';

            if ($payment_status == 'completed') {
                $message = '<br/>' . __('پرداخت با موفقیت انجام شد . کد تراکنش : ', 'rcp_sepordeh') . $transaction_id . '<br/>';
            }

            if ($payment_status == 'cancelled') {
                $message = '<br/>' . __('تراکنش به دلیل انصراف شما نا تمام باقی ماند .', 'rcp_sepordeh');
            }

            if ($payment_status == 'failed') {
                $message = '<br/>' . __('تراکنش به دلیل خطای زیر ناموفق باقی باند :', 'rcp_sepordeh') . '<br/>' . $fault . '<br/>';
            }

            return $content . $message;
        }

        private function Fault($error)
        {
            $response = '';
            switch ($error) {

                case '-1':
                    $response = __('اطلاعات ارسال شده ناقص است .', 'rcp_sepordeh');
                    break;

                case '-2':
                    $response = __('آی پی یا مرچنت سپرده اشتباه است .', 'rcp_sepordeh');
                    break;

                case '-3':
                    $response = __('با توجه به محدودیت های شاپرک امکان پرداخت با رقم درخواست شده میسر نمیباشد .', 'rcp_sepordeh');
                    break;

                case '-4':
                    $response = __('سطح تایید پذیرنده پایین تر از سطح نقره ای میباشد .', 'rcp_sepordeh');
                    break;

                case '-11':
                    $response = __('درخواست مورد نظر یافت نشد .', 'rcp_sepordeh');
                    break;

                case '-21':
                    $response = __('هیچ نوع عملیات مالی برای این تراکنش یافت نشد .', 'rcp_sepordeh');
                    break;

                case '-22':
                    $response = __('تراکنش نا موفق میباشد .', 'rcp_sepordeh');
                    break;

                case '-33':
                    $response = __('رقم تراکنش با رقم وارد شده مطابقت ندارد .', 'rcp_sepordeh');
                    break;

                case '-40':
                    $response = __('اجازه دسترسی به متد مورد نظر وجود ندارد .', 'rcp_sepordeh');
                    break;

                case '-54':
                    $response = __('درخواست مورد نظر آرشیو شده است .', 'rcp_sepordeh');
                    break;

                case '200':
                    $response = __('اتصال با سپرده به خوبی برقرار شد و همه چیز صحیح است .', 'rcp_sepordeh');
                    break;

                case '101':
                    $response = __('تراکنش با موفقیت به پایان رسیده بود و تاییدیه آن نیز انجام شده بود .', 'rcp_sepordeh');
                    break;

            }

            return $response;
        }

    }
}
new RCP_Sepordeh();
if (!function_exists('change_cancelled_to_pending_By_HANNANStd')) {
    add_action('rcp_set_status', 'change_cancelled_to_pending_By_HANNANStd', 10, 2);
    function change_cancelled_to_pending_By_HANNANStd($status, $user_id)
    {
        if ('cancelled' == $status) {
            rcp_set_status($user_id, 'expired');
        }

        return true;
    }
}

if (!function_exists('RCP_User_Registration_Data_By_HANNANStd') && !function_exists('RCP_User_Registration_Data')) {
    add_filter('rcp_user_registration_data', 'RCP_User_Registration_Data_By_HANNANStd');
    function RCP_User_Registration_Data_By_HANNANStd($user)
    {
        $old_subscription_id = get_user_meta($user['id'], 'rcp_subscription_level', true);
        if (!empty($old_subscription_id)) {
            update_user_meta($user['id'], 'rcp_subscription_level_old', $old_subscription_id);
        }

        $user_info = get_userdata($user['id']);
        $old_user_role = implode(', ', $user_info->roles);
        if (!empty($old_user_role)) {
            update_user_meta($user['id'], 'rcp_user_role_old', $old_user_role);
        }

        return $user;
    }
}

if (!function_exists('RCP_check_verifications')) {
    function RCP_check_verifications($gateway, $params)
    {

        if (!function_exists('rcp_get_payment_meta_db_name')) {
            return;
        }

        if (is_array($params) || is_object($params)) {
            $params = implode('_', (array) $params);
        }
        if (empty($params) || trim($params) == '') {
            return;
        }

        $gateway = str_ireplace(array('RCP_', 'bank'), array('', ''), $gateway);
        $params = trim(strtolower($gateway) . '_' . $params);

        $table = rcp_get_payment_meta_db_name();

        global $wpdb;
        $check = $wpdb->get_row($wpdb->prepare("SELECT * FROM {$table} WHERE meta_key='_verification_params' AND meta_value='%s'", $params));

        if (!empty($check)) {
            wp_die('وضعیت این تراکنش قبلا مشخص شده بود.');
        }
    }
}

if (!function_exists('RCP_set_verifications')) {
    function RCP_set_verifications($payment_id, $gateway, $params)
    {

        if (!function_exists('rcp_get_payment_meta_db_name')) {
            return;
        }

        if (is_array($params) || is_object($params)) {
            $params = implode('_', (array) $params);
        }
        if (empty($params) || trim($params) == '') {
            return;
        }

        $gateway = str_ireplace(array('RCP_', 'bank'), array('', ''), $gateway);
        $params = trim(strtolower($gateway) . '_' . $params);

        $table = rcp_get_payment_meta_db_name();

        global $wpdb;
        $wpdb->insert($table, array(
            'rcp_payment_id' => $payment_id,
            'meta_key' => '_verification_params',
            'meta_value' => $params,
        ), array('%d', '%s', '%s'));
    }
}
?>
